local colorstack = {}

function color_push()
    local depth = #colorstack +1
    colorstack[depth] = {}
	colorstack[depth].r, colorstack[depth].g, colorstack[depth].b, 
        colorstack[depth].a = love.graphics.getColor()
end


function color_pop()
	love.graphics.setColor(colorstack[#colorstack].r, colorstack[#colorstack].g,
		colorstack[#colorstack].b, colorstack[#colorstack].a)
	table.remove(colorstack, #colorstack)
end


function assert_num(name, count, ...)
	local args = { ... }
	for i = 1, count do
		assert(args[i] ~= nil, "Argument " .. i .. " to " .. name .. " may not be nil and must be an int!")
		assert(type(args[i]) == "number", "Argument " .. i .. " to " .. name .. " must be an int!")
		assert(args[i] == args[i], "Argument " .. i .. " to " .. name .. " must not be NaN!")
	end
end


function assert_num_or_nil(name, count, ...)
	local args = { ... }
	for i = 1, count do
		if (args[i] ~= nil) then
			assert(type(args[i]) == "number", "Argument " .. i .. " to " .. name .. " can only be of type int!")
			assert(args[i] == args[i], "Argument " .. i .. " to " .. name .. " may not be NaN!")
		end
	end
end


local recordSeperator = string.char(30)
local unitSeperator = string.char(31)


function unit(...)
	local args = { ... }
	local string = args[1]
	for i=2, #args do
		string = string .. unitSeperator .. args[i]
	end
	return string
end


function record(...)
	local args = { ... }
	local string = args[1]
	for i=2, #args do
		string = string .. recordSeperator .. args[i]
	end
	return string
end
